/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ClusterNetworkPanel.java
 *
 * Created on 06-abr-2011, 22:46:38
 */
package scimat.gui.components.analysisview;

import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import org.apache.batik.swing.JSVGCanvas;
import org.apache.batik.swing.JSVGScrollPane;
import org.w3c.dom.Document;
import scimat.api.mapping.WholeNetwork;
import scimat.api.mapping.clustering.result.Cluster;
import scimat.api.visualization.graph.ClusterNetworkSVG;
import scimat.analysis.KeyProperties;

/**
 *
 * @author mjcobo
 */
public class ClusterNetworkPanel extends javax.swing.JPanel {

  /** Creates new form ClusterNetworkPanel */
  public ClusterNetworkPanel() {
    this.svgCanvas = new JSVGCanvas();
    this.svgScrollPane = new JSVGScrollPane(svgCanvas);
    this.clusterNetworkSVG = new ClusterNetworkSVG(400, 50, 10, 10);

    initComponents();

    this.addComponentListener(new ComponentAdapter() {

      @Override
      public void componentResized(ComponentEvent e) {


        svgCanvas.setDocument(document);
      }


    });
    
    this.document = this.clusterNetworkSVG.buildEmptyXML();
    this.svgCanvas.setDocument(this.document);
    this.svgCanvas.setDocumentState(JSVGCanvas.ALWAYS_DYNAMIC);

    add(this.svgScrollPane);
  }

  /**
   * 
   */
  public void refresh() {
  
    this.svgCanvas.setDocument(null);

    this.svgCanvas.validate();
  }
  
  /**
   *
   * @param strategicDiagram
   */
  public void refreshData(Cluster cluster, WholeNetwork wholeNetwork, double maxSize) {

    this.document = this.clusterNetworkSVG.buildXML(cluster, wholeNetwork, KeyProperties.__KEY_NODE_FREQUENCY, KeyProperties.__KEY_NODE_LABEL, maxSize);

    //System.out.println(new DomToString().convert(document));

    this.svgCanvas.setDocument(document);

    this.svgCanvas.validate();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.LINE_AXIS));
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables
  private JSVGCanvas svgCanvas;
  private JSVGScrollPane svgScrollPane;
  private Document document;
  private ClusterNetworkSVG clusterNetworkSVG;
}
