/*
 * StrategicDiagramPanel.java
 *
 * Created on 06-abr-2011, 13:02:17
 */
package scimat.gui.components.analysisview;

import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import org.apache.batik.swing.JSVGCanvas;
import org.apache.batik.swing.JSVGScrollPane;
import org.w3c.dom.Document;
import scimat.api.analysis.category.StrategicDiagram;
import scimat.api.visualization.category.StrategicDiagramSVG;

/**
 *
 * @author mjcobo
 */
public class StrategicDiagramPanel extends javax.swing.JPanel {

  /** Creates new form StrategicDiagramPanel */
  public StrategicDiagramPanel() {

    this.svgCanvas = new JSVGCanvas();
    this.svgScrollPane = new JSVGScrollPane(svgCanvas);
    this.strategicDiagramSVG = new StrategicDiagramSVG(400, 30, 5, 12);

    initComponents();

    this.addComponentListener(new ComponentAdapter() {

      @Override
      public void componentResized(ComponentEvent e) {
        
        svgCanvas.setDocument(document);
      }
    });


    this.document = this.strategicDiagramSVG.buildXML(new StrategicDiagram());
    this.svgCanvas.setDocument(this.document);
    this.svgCanvas.setDocumentState(JSVGCanvas.ALWAYS_DYNAMIC);

    add(this.svgScrollPane);
  }

  /**
   * 
   * @param strategicDiagram
   */
  public void refreshItems(StrategicDiagram strategicDiagram) {

    this.document = this.strategicDiagramSVG.buildXML(strategicDiagram);
    
    this.svgCanvas.setDocument(document);

    //validate();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.LINE_AXIS));
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables
  //private JSVGCanvas svgCanvas;
  private JSVGCanvas svgCanvas;
  private JSVGScrollPane svgScrollPane;
  private Document document;
  private StrategicDiagramSVG strategicDiagramSVG;
}
