/*
 * AuthorDetailPanel.java
 *
 * Created on 26-nov-2008, 19:59:00
 */
package scimat.gui.components.detailspanel;

import java.util.ArrayList;
import scimat.model.knowledgebase.entity.AuthorReference;
import scimat.model.knowledgebase.exception.KnowledgeBaseException;
import scimat.project.CurrentProject;



/**
 *
 * @author Manuel Jesus Cobo Martin.
 */
public class AuthorReferenceDetailPanel extends GenericDetailPanel<AuthorReference> {

  /** 
   * Creates new form AuthorDetailPanel
   */
  public AuthorReferenceDetailPanel() {
    initComponents();

    CurrentProject.getInstance().getKbObserver().addAuthorReferenceObserver(this);
  }

  /**
   *
   */
  public void reset() {

    idTextField.setText("");
    authorNameTextField.setText("");

    setEnableTextField(false);
  }

  /**
   *
   */
  public void setEnableTextField(boolean enabled) {

    idTextField.setEnabled(enabled);
    authorNameTextField.setEnabled(enabled);
  }

  /**
   * 
   * @param authorReference
   */
  public void refreshItem(AuthorReference authorReference) {

    this.authorReference = authorReference;

    if (authorReference != null) {

      idTextField.setText(this.authorReference.getAuthorReferenceID().toString());
      authorNameTextField.setText(this.authorReference.getAuthorName());

      setEnableTextField(true);

    } else {

      reset();

    }
  }

  /**
   *
   * @return
   */
  public String getAuthorName() {

    return authorNameTextField.getText();
  }

  public void entityAdded(ArrayList<AuthorReference> items) throws KnowledgeBaseException {
    // Do Nothing
  }

  public void entityRefresh() throws KnowledgeBaseException {
    // Do Nothing
  }

  public void entityUpdated(ArrayList<AuthorReference> items) throws KnowledgeBaseException {

    int position;

    position = items.indexOf(this.authorReference);

    if (position != -1) {

      refreshItem(items.get(position));

    }
  }

  public void entityRemoved(ArrayList<AuthorReference> items) throws KnowledgeBaseException {
    // Do Nothing
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    idDescriptionLabel = new javax.swing.JLabel();
    idTextField = new javax.swing.JTextField();
    authorNameDescriptionLabel = new javax.swing.JLabel();
    authorNameTextField = new javax.swing.JTextField();

    idDescriptionLabel.setText("ID:");

    idTextField.setEditable(false);

    authorNameDescriptionLabel.setText("Name:");

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(idDescriptionLabel)
          .addComponent(authorNameDescriptionLabel))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(layout.createSequentialGroup()
            .addComponent(idTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap(98, Short.MAX_VALUE))
          .addComponent(authorNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 159, Short.MAX_VALUE)))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(idDescriptionLabel)
          .addComponent(idTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(authorNameDescriptionLabel)
          .addComponent(authorNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel authorNameDescriptionLabel;
  private javax.swing.JTextField authorNameTextField;
  private javax.swing.JLabel idDescriptionLabel;
  private javax.swing.JTextField idTextField;
  // End of variables declaration//GEN-END:variables
  private AuthorReference authorReference;
}
