/*
 * UpdateDocumentWordRolDialog.java
 *
 * Created on 27-may-2011, 18:58:46
 */
package scimat.gui.components.editdialog;

import scimat.gui.commands.edit.update.UpdateDocumentWordRolEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.DocumentWord;

/**
 *
 * @author mjcobo
 */
public class UpdateDocumentWordRolDialog extends javax.swing.JDialog {

  /** Creates new form UpdateDocumentWordRolDialog */
  public UpdateDocumentWordRolDialog(java.awt.Frame parent) {
    super(parent, true);
    initComponents();
  }

  /**
   * 
   * @param documentWord 
   */
  public void refreshData(DocumentWord documentWord) {
  
    this.documentWord = documentWord;
    
    this.authorKeywordCheckBox.setSelected(this.documentWord.isAuthorKeyword());
    this.sourceKeywordCheckBox.setSelected(this.documentWord.isSourceKeyword());
    this.addedKeywordCheckBox.setSelected(this.documentWord.isAddedKeyword());
  }
  
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        authorKeywordCheckBox = new javax.swing.JCheckBox();
        sourceKeywordCheckBox = new javax.swing.JCheckBox();
        addedKeywordCheckBox = new javax.swing.JCheckBox();
        separator = new javax.swing.JSeparator();
        updateButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Update word rol");

        authorKeywordCheckBox.setText("Author keyword");

        sourceKeywordCheckBox.setText("Source keyword");

        addedKeywordCheckBox.setText("Added keyword");

        updateButton.setText("Update");
        updateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(separator, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 231, Short.MAX_VALUE)
                    .add(authorKeywordCheckBox)
                    .add(sourceKeywordCheckBox)
                    .add(addedKeywordCheckBox)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(updateButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(cancelButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(authorKeywordCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(sourceKeywordCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(addedKeywordCheckBox)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(separator, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cancelButton)
                    .add(updateButton))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void updateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateButtonActionPerformed
    
    (new PerformKnowledgeBaseEditTask(new UpdateDocumentWordRolEdit(this.documentWord.getDocument().getDocumentID(), 
            this.documentWord.getWord().getWordID(),
            this.authorKeywordCheckBox.isSelected(), 
            this.sourceKeywordCheckBox.isSelected(), 
            this.addedKeywordCheckBox.isSelected()), rootPane)).execute();
    
    dispose();
  }//GEN-LAST:event_updateButtonActionPerformed
  
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox addedKeywordCheckBox;
    private javax.swing.JCheckBox authorKeywordCheckBox;
    private javax.swing.JButton cancelButton;
    private javax.swing.JSeparator separator;
    private javax.swing.JCheckBox sourceKeywordCheckBox;
    private javax.swing.JButton updateButton;
    // End of variables declaration//GEN-END:variables
  private DocumentWord documentWord;
}
