/*
 * GlobalReplaceAffiliationPanel.java
 *
 * Created on 22-ene-2012, 17:52:08
 */
package scimat.gui.components.globalreplace;

import scimat.gui.commands.edit.globalreplace.GlobalReplaceAuthorsEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;

/**
 *
 * @author mjcobo
 */
public class GlobalReplaceAuthorPanel extends GlobalReplaceSelectFieldsPanel {

  /** Creates new form GlobalReplaceAffiliationPanel */
  public GlobalReplaceAuthorPanel() {
    initComponents();
  }

  /**
   * 
   */
  @Override
  public void fireIncorrectDataObservers() {
    
    if (this.fieldsSelected > 0) {

      notifyIncorrectDataObservers(true, "");

    } else {

      notifyIncorrectDataObservers(false, "A set of fields must be selected");
    }
  }

  /**
   * 
   * @param find
   * @param replace 
   */
  @Override
  public void doGlobalReplaceAction(String find, String replace) {
    
    new PerformKnowledgeBaseEditTask(new GlobalReplaceAuthorsEdit(find, 
            replace, 
            this.authorNameCheckBox.isSelected(), 
            this.fullAuthorNameCheckBox.isSelected()), this).execute();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        authorNameCheckBox = new javax.swing.JCheckBox();
        fullAuthorNameCheckBox = new javax.swing.JCheckBox();

        authorNameCheckBox.setText("Name");
        authorNameCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                authorNameCheckBoxActionPerformed(evt);
            }
        });

        fullAuthorNameCheckBox.setText("Full name");
        fullAuthorNameCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fullAuthorNameCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(authorNameCheckBox)
                    .addComponent(fullAuthorNameCheckBox)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(authorNameCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(fullAuthorNameCheckBox)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt 
   */
  private void authorNameCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_authorNameCheckBoxActionPerformed
    
    if (this.authorNameCheckBox.isSelected()) {

      this.fieldsSelected ++;

    } else {

      this.fieldsSelected --;
    }

    fireIncorrectDataObservers();
  }//GEN-LAST:event_authorNameCheckBoxActionPerformed

  /**
   * 
   * @param evt 
   */
  private void fullAuthorNameCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fullAuthorNameCheckBoxActionPerformed
    
    if (this.fullAuthorNameCheckBox.isSelected()) {

      this.fieldsSelected ++;

    } else {

      this.fieldsSelected --;
    }

    fireIncorrectDataObservers();
  }//GEN-LAST:event_fullAuthorNameCheckBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox authorNameCheckBox;
    private javax.swing.JCheckBox fullAuthorNameCheckBox;
    // End of variables declaration//GEN-END:variables
  private int fieldsSelected = 0;
}
