/*
 * AuthorGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:10:55
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateAuthorEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.Author;

/**
 *
 * @author mjcobo
 */
public class AuthorGlobalSlavePanel extends GlobalSlavePanel<Author> {

  /** Creates new form AuthorGlobalSlavePanel */
  public AuthorGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(Author item) {

    setMasterItem(item);

    this.authorDetailPanel.refreshItem(item);
    this.authorSlaveAuthorGroupPanel.setMasterItem(item);
    this.authorSlaveAffiliationsPanel.setMasterItem(item);
    this.authorSlaveDocumentsPanel.setMasterItem(item);

    if (item != null) {
      
      this.updateAuthorButton.setEnabled(true);

    } else {
      
      this.updateAuthorButton.setEnabled(false);
      
    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowAuthorPanel = new scimat.gui.components.HideAndShowPanel();
    authorInfoPanel = new javax.swing.JPanel();
    authorDetailPanel = new scimat.gui.components.detailspanel.AuthorDetailPanel();
    updateAuthorButton = new javax.swing.JButton();
    hideAndShowAuthorGroupPanel = new scimat.gui.components.HideAndShowPanel();
    authorGroupInfoPanel = new javax.swing.JPanel();
    authorSlaveAuthorGroupPanel = new scimat.gui.components.slavepanel.AuthorSlaveAuthorGroupPanel();
    hideAndShowAffiliationPanel = new scimat.gui.components.HideAndShowPanel();
    affiliationInfoPanel = new javax.swing.JPanel();
    authorSlaveAffiliationsPanel = new scimat.gui.components.slavepanel.AuthorSlaveAffiliationsPanel();
    hideAndShowDocumentPanel = new scimat.gui.components.HideAndShowPanel();
    documentInfoPanel = new javax.swing.JPanel();
    authorSlaveDocumentsPanel = new scimat.gui.components.slavepanel.AuthorSlaveDocumentsPanel();

    this.hideAndShowAuthorPanel.setDescription("Author info");
    this.hideAndShowAuthorPanel.setPanel(this.authorInfoPanel);

    updateAuthorButton.setText("Update");
    updateAuthorButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateAuthorButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout authorInfoPanelLayout = new javax.swing.GroupLayout(authorInfoPanel);
    authorInfoPanel.setLayout(authorInfoPanelLayout);
    authorInfoPanelLayout.setHorizontalGroup(
      authorInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateAuthorButton))
      .addComponent(authorDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    authorInfoPanelLayout.setVerticalGroup(
      authorInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorInfoPanelLayout.createSequentialGroup()
        .addComponent(authorDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateAuthorButton))
    );

    this.hideAndShowAuthorGroupPanel.setDescription("Author group info");
    this.hideAndShowAuthorGroupPanel.setPanel(this.authorGroupInfoPanel);

    javax.swing.GroupLayout authorGroupInfoPanelLayout = new javax.swing.GroupLayout(authorGroupInfoPanel);
    authorGroupInfoPanel.setLayout(authorGroupInfoPanelLayout);
    authorGroupInfoPanelLayout.setHorizontalGroup(
      authorGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorSlaveAuthorGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    authorGroupInfoPanelLayout.setVerticalGroup(
      authorGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(authorGroupInfoPanelLayout.createSequentialGroup()
        .addComponent(authorSlaveAuthorGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(40, Short.MAX_VALUE))
    );

    this.hideAndShowAffiliationPanel.setDescription("Affiliations info");
    this.hideAndShowAffiliationPanel.setPanel(this.affiliationInfoPanel);

    javax.swing.GroupLayout affiliationInfoPanelLayout = new javax.swing.GroupLayout(affiliationInfoPanel);
    affiliationInfoPanel.setLayout(affiliationInfoPanelLayout);
    affiliationInfoPanelLayout.setHorizontalGroup(
      affiliationInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorSlaveAffiliationsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    affiliationInfoPanelLayout.setVerticalGroup(
      affiliationInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorSlaveAffiliationsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 131, Short.MAX_VALUE)
    );

    this.hideAndShowDocumentPanel.setDescription("Documents info");
    this.hideAndShowDocumentPanel.setPanel(this.documentInfoPanel);

    javax.swing.GroupLayout documentInfoPanelLayout = new javax.swing.GroupLayout(documentInfoPanel);
    documentInfoPanel.setLayout(documentInfoPanelLayout);
    documentInfoPanelLayout.setHorizontalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorSlaveDocumentsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    documentInfoPanelLayout.setVerticalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorSlaveDocumentsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 164, Short.MAX_VALUE)
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(documentInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(authorInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorGroupPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(authorGroupInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAffiliationPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(affiliationInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAuthorGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAffiliationPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(affiliationInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(documentInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateAuthorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateAuthorButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.authorDetailPanel.getAuthorName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a name.\nPlease, " +
        "give a name for the author.", "Invalid author name", JOptionPane.ERROR_MESSAGE);

    } else if (this.authorDetailPanel.getFullAuthorName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a full name.\nPlease, " +
        "give a full name for the author.", "Invalid full author name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateAuthorEdit(getMasterItem().getAuthorID(),
              this.authorDetailPanel.getAuthorName(),
              this.authorDetailPanel.getFullAuthorName()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateAuthorButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel affiliationInfoPanel;
  private scimat.gui.components.detailspanel.AuthorDetailPanel authorDetailPanel;
  private javax.swing.JPanel authorGroupInfoPanel;
  private javax.swing.JPanel authorInfoPanel;
  private scimat.gui.components.slavepanel.AuthorSlaveAffiliationsPanel authorSlaveAffiliationsPanel;
  private scimat.gui.components.slavepanel.AuthorSlaveAuthorGroupPanel authorSlaveAuthorGroupPanel;
  private scimat.gui.components.slavepanel.AuthorSlaveDocumentsPanel authorSlaveDocumentsPanel;
  private javax.swing.JPanel documentInfoPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAffiliationPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowDocumentPanel;
  private javax.swing.JButton updateAuthorButton;
  // End of variables declaration//GEN-END:variables
}
