/*
 * AuthorReferenceGroupGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:12:23
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateAuthorReferenceGroupEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.AuthorReferenceGroup;

/**
 *
 * @author mjcobo
 */
public class AuthorReferenceGroupGlobalSlavePanel extends GlobalSlavePanel<AuthorReferenceGroup> {

  /** Creates new form AuthorReferenceGroupGlobalSlavePanel */
  public AuthorReferenceGroupGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(AuthorReferenceGroup item) {

    setMasterItem(item);

    this.authorReferenceGroupDetailPanel.refreshItem(item);
    this.authorReferenceGroupSlaveAuthorReferencesPanel.setMasterItem(item);

    if (item != null) {
      
      this.updateAuthorReferenceGroupButton.setEnabled(true);

    } else {

      this.updateAuthorReferenceGroupButton.setEnabled(false);

    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowAuthorReferenceGroupPanel = new scimat.gui.components.HideAndShowPanel();
    authorReferenceGroupInfoPanel = new javax.swing.JPanel();
    updateAuthorReferenceGroupButton = new javax.swing.JButton();
    authorReferenceGroupDetailPanel = new scimat.gui.components.detailspanel.AuthorReferenceGroupDetailPanel();
    hideAndShowAuthorReferencePanel = new scimat.gui.components.HideAndShowPanel();
    authorReferenceInfoPanel = new javax.swing.JPanel();
    authorReferenceGroupSlaveAuthorReferencesPanel = new scimat.gui.components.slavepanel.AuthorReferenceGroupSlaveAuthorReferencesPanel();

    this.hideAndShowAuthorReferenceGroupPanel.setDescription("Author reference group info");
    this.hideAndShowAuthorReferenceGroupPanel.setPanel(this.authorReferenceGroupInfoPanel);

    updateAuthorReferenceGroupButton.setText("Update");
    updateAuthorReferenceGroupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateAuthorReferenceGroupButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout authorReferenceGroupInfoPanelLayout = new javax.swing.GroupLayout(authorReferenceGroupInfoPanel);
    authorReferenceGroupInfoPanel.setLayout(authorReferenceGroupInfoPanelLayout);
    authorReferenceGroupInfoPanelLayout.setHorizontalGroup(
      authorReferenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorReferenceGroupInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateAuthorReferenceGroupButton))
      .addComponent(authorReferenceGroupDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    authorReferenceGroupInfoPanelLayout.setVerticalGroup(
      authorReferenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorReferenceGroupInfoPanelLayout.createSequentialGroup()
        .addComponent(authorReferenceGroupDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateAuthorReferenceGroupButton))
    );

    this.hideAndShowAuthorReferencePanel.setDescription("Author references info");
    this.hideAndShowAuthorReferencePanel.setPanel(this.authorReferenceInfoPanel);

    javax.swing.GroupLayout authorReferenceInfoPanelLayout = new javax.swing.GroupLayout(authorReferenceInfoPanel);
    authorReferenceInfoPanel.setLayout(authorReferenceInfoPanelLayout);
    authorReferenceInfoPanelLayout.setHorizontalGroup(
      authorReferenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorReferenceGroupSlaveAuthorReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    authorReferenceInfoPanelLayout.setVerticalGroup(
      authorReferenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorReferenceGroupSlaveAuthorReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(authorReferenceGroupInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorReferenceGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(authorReferenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorReferencePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowAuthorReferenceGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorReferenceGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAuthorReferencePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorReferenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateAuthorReferenceGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateAuthorReferenceGroupButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.authorReferenceGroupDetailPanel.getGroupName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a group name.\nPlease, " +
        "give a name for the group.", "Invalid group name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateAuthorReferenceGroupEdit(getMasterItem().getAuthorReferenceGroupID(),
              this.authorReferenceGroupDetailPanel.getGroupName(),
              this.authorReferenceGroupDetailPanel.isStopGroup()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateAuthorReferenceGroupButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private scimat.gui.components.detailspanel.AuthorReferenceGroupDetailPanel authorReferenceGroupDetailPanel;
  private javax.swing.JPanel authorReferenceGroupInfoPanel;
  private scimat.gui.components.slavepanel.AuthorReferenceGroupSlaveAuthorReferencesPanel authorReferenceGroupSlaveAuthorReferencesPanel;
  private javax.swing.JPanel authorReferenceInfoPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorReferenceGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorReferencePanel;
  private javax.swing.JButton updateAuthorReferenceGroupButton;
  // End of variables declaration//GEN-END:variables
}
