/*
 * JournalGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:13:20
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateJournalEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.Journal;

/**
 *
 * @author mjcobo
 */
public class JournalGlobalSlavePanel extends GlobalSlavePanel<Journal> {

  /** Creates new form JournalGlobalSlavePanel */
  public JournalGlobalSlavePanel() {
    initComponents();
  }

  /**
   *
   * @param item
   */
  @Override
  public void refresh(Journal item) {

    setMasterItem(item);

    this.journalDetailPanel.refreshItem(item);
    this.journalSlaveDocumentsPanel.setMasterItem(item);
    this.journalSlaveJournalSubjectCategoryPublishDatePanel.setMasterItem(item);

    if (item != null) {
      
      this.updateJournalButton.setEnabled(true);

    } else {
      
      this.updateJournalButton.setEnabled(false);

    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowJournalPanel = new scimat.gui.components.HideAndShowPanel();
    journalInfoPanel = new javax.swing.JPanel();
    updateJournalButton = new javax.swing.JButton();
    journalDetailPanel = new scimat.gui.components.detailspanel.JournalDetailPanel();
    hideAndShowDocumentPanel = new scimat.gui.components.HideAndShowPanel();
    documentInfoPanel = new javax.swing.JPanel();
    journalSlaveDocumentsPanel = new scimat.gui.components.slavepanel.JournalSlaveDocumentsPanel();
    hideAndShowSubjectCategoryPanel = new scimat.gui.components.HideAndShowPanel();
    subjectCategoryPanel = new javax.swing.JPanel();
    journalSlaveJournalSubjectCategoryPublishDatePanel = new scimat.gui.components.slavepanel.JournalSlaveJournalSubjectCategoryPublishDatePanel();

    this.hideAndShowJournalPanel.setDescription("Journal info");
    this.hideAndShowJournalPanel.setPanel(this.journalInfoPanel);

    updateJournalButton.setText("Update");
    updateJournalButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateJournalButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout journalInfoPanelLayout = new javax.swing.GroupLayout(journalInfoPanel);
    journalInfoPanel.setLayout(journalInfoPanelLayout);
    journalInfoPanelLayout.setHorizontalGroup(
      journalInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, journalInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateJournalButton))
      .addComponent(journalDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    journalInfoPanelLayout.setVerticalGroup(
      journalInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, journalInfoPanelLayout.createSequentialGroup()
        .addComponent(journalDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateJournalButton))
    );

    this.hideAndShowDocumentPanel.setDescription("Documents info");
    this.hideAndShowDocumentPanel.setPanel(this.documentInfoPanel);

    javax.swing.GroupLayout documentInfoPanelLayout = new javax.swing.GroupLayout(documentInfoPanel);
    documentInfoPanel.setLayout(documentInfoPanelLayout);
    documentInfoPanelLayout.setHorizontalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(journalSlaveDocumentsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    documentInfoPanelLayout.setVerticalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(journalSlaveDocumentsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 131, Short.MAX_VALUE)
    );

    this.hideAndShowSubjectCategoryPanel.setDescription("Subject categories info");
    this.hideAndShowSubjectCategoryPanel.setPanel(this.subjectCategoryPanel);

    javax.swing.GroupLayout subjectCategoryPanelLayout = new javax.swing.GroupLayout(subjectCategoryPanel);
    subjectCategoryPanel.setLayout(subjectCategoryPanelLayout);
    subjectCategoryPanelLayout.setHorizontalGroup(
      subjectCategoryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(journalSlaveJournalSubjectCategoryPublishDatePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    subjectCategoryPanelLayout.setVerticalGroup(
      subjectCategoryPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(journalSlaveJournalSubjectCategoryPublishDatePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 131, Short.MAX_VALUE)
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(subjectCategoryPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(journalInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowJournalPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(documentInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowSubjectCategoryPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowJournalPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(journalInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(documentInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowSubjectCategoryPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(subjectCategoryPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateJournalButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateJournalButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.journalDetailPanel.getSource().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a source.\nPlease, " +
        "give a source for the journal.", "Invalid journal source", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateJournalEdit(getMasterItem().getJournalID(),
              this.journalDetailPanel.getSource(),
              this.journalDetailPanel.getConferenceInformation()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateJournalButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel documentInfoPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowDocumentPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowJournalPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowSubjectCategoryPanel;
  private scimat.gui.components.detailspanel.JournalDetailPanel journalDetailPanel;
  private javax.swing.JPanel journalInfoPanel;
  private scimat.gui.components.slavepanel.JournalSlaveDocumentsPanel journalSlaveDocumentsPanel;
  private scimat.gui.components.slavepanel.JournalSlaveJournalSubjectCategoryPublishDatePanel journalSlaveJournalSubjectCategoryPublishDatePanel;
  private javax.swing.JPanel subjectCategoryPanel;
  private javax.swing.JButton updateJournalButton;
  // End of variables declaration//GEN-END:variables
}
