/*
 * PeriodGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:11:42
 */
package scimat.gui.components.globalslavepanel;

import java.util.ArrayList;
import java.util.TreeSet;
import javax.swing.JOptionPane;
import scimat.gui.commands.edit.delete.DeletePublishDatesFromPeriodEdit;
import scimat.gui.commands.edit.update.UpdatePeriodEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.gui.components.ErrorDialogManager;
import scimat.gui.components.SelectionObserverButton;
import scimat.gui.components.adddialog.AddDialogManager;
import scimat.model.knowledgebase.dao.PeriodDAO;
import scimat.model.knowledgebase.dao.PublishDateDAO;
import scimat.model.knowledgebase.entity.Period;
import scimat.model.knowledgebase.entity.PublishDate;
import scimat.model.knowledgebase.exception.KnowledgeBaseException;
import scimat.project.CurrentProject;

/**
 *
 * @author mjcobo
 */
public class PeriodGlobalSlavePanel extends GlobalSlavePanel<Period> {

  /** Creates new form PeriodGlobalSlavePanel */
  public PeriodGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(Period item) {

    boolean flag;
    
    setMasterItem(item);

    this.periodDetailPanel.refreshItem(item);
    this.periodSlavePublishDatesPanel.setMasterItem(item);

    flag = item != null;
      
    this.updatePeriodButton.setEnabled(flag);
    this.addPublishDateButton.setEnabled(flag);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowPeriodPanel = new scimat.gui.components.HideAndShowPanel();
    periodInfoPanel = new javax.swing.JPanel();
    updatePeriodButton = new javax.swing.JButton();
    periodDetailPanel = new scimat.gui.components.detailspanel.PeriodDetailPanel();
    hideAndShowPublishDatePanel = new scimat.gui.components.HideAndShowPanel();
    publishDateInfoPanel = new javax.swing.JPanel();
    periodSlavePublishDatesPanel = new scimat.gui.components.slavepanel.PeriodSlavePublishDatesPanel();
    addPublishDateButton = new javax.swing.JButton();
    deletePublishDatesButton = new SelectionObserverButton(1,-1);
    this.periodSlavePublishDatesPanel.addSelectionObserver(this.deletePublishDatesButton);

    this.hideAndShowPeriodPanel.setDescription("Period info");
    this.hideAndShowPeriodPanel.setPanel(this.periodInfoPanel);

    updatePeriodButton.setText("Update");
    updatePeriodButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updatePeriodButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout periodInfoPanelLayout = new javax.swing.GroupLayout(periodInfoPanel);
    periodInfoPanel.setLayout(periodInfoPanelLayout);
    periodInfoPanelLayout.setHorizontalGroup(
      periodInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, periodInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updatePeriodButton))
      .addComponent(periodDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    periodInfoPanelLayout.setVerticalGroup(
      periodInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, periodInfoPanelLayout.createSequentialGroup()
        .addComponent(periodDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updatePeriodButton))
    );

    this.hideAndShowPublishDatePanel.setDescription("Publish dates info");
    this.hideAndShowPublishDatePanel.setPanel(this.publishDateInfoPanel);

    addPublishDateButton.setText("Add");
    addPublishDateButton.setEnabled(false);
    addPublishDateButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addPublishDateButtonActionPerformed(evt);
      }
    });

    deletePublishDatesButton.setText("Delete");
    deletePublishDatesButton.setEnabled(false);
    deletePublishDatesButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deletePublishDatesButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout publishDateInfoPanelLayout = new javax.swing.GroupLayout(publishDateInfoPanel);
    publishDateInfoPanel.setLayout(publishDateInfoPanelLayout);
    publishDateInfoPanelLayout.setHorizontalGroup(
      publishDateInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, publishDateInfoPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(addPublishDateButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(deletePublishDatesButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
      .addComponent(periodSlavePublishDatesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    publishDateInfoPanelLayout.setVerticalGroup(
      publishDateInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, publishDateInfoPanelLayout.createSequentialGroup()
        .addComponent(periodSlavePublishDatesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 121, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(publishDateInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(addPublishDateButton)
          .addComponent(deletePublishDatesButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(publishDateInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(periodInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowPeriodPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(hideAndShowPublishDatePanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowPeriodPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(periodInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowPublishDatePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(publishDateInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updatePeriodButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updatePeriodButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.periodDetailPanel.getPeriodName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a name.\nPlease, " +
        "give a name for the period.", "Invalid period name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdatePeriodEdit(getMasterItem().getPeriodID(),
              this.periodDetailPanel.getPeriodName(), this.periodDetailPanel.getPosition()), this);

      task.execute();
    }
  }//GEN-LAST:event_updatePeriodButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deletePublishDatesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deletePublishDatesButtonActionPerformed
    
    (new PerformKnowledgeBaseEditTask(new DeletePublishDatesFromPeriodEdit(getMasterItem(), 
              this.periodSlavePublishDatesPanel.getSelectedItems()), this)).execute();
  }//GEN-LAST:event_deletePublishDatesButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addPublishDateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addPublishDateButtonActionPerformed
   
    
    try {
      
      PeriodDAO periodDAO = CurrentProject.getInstance().getFactoryDAO().getPeriodDAO();
      PublishDateDAO publishDateDAO = CurrentProject.getInstance().getFactoryDAO().getPublishDateDAO();
      
      ArrayList<PublishDate> publishDatesInDocument = periodDAO.getPublishDates(getMasterItem().getPeriodID());
      TreeSet<PublishDate> possiblePublishDates = new TreeSet<PublishDate>(publishDateDAO.getPublishDates());
      
      possiblePublishDates.removeAll(publishDatesInDocument);
      
      AddDialogManager.getInstance().showAddPublishDatesToPeriodDialog(getMasterItem(), new ArrayList<PublishDate>(possiblePublishDates));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
  }//GEN-LAST:event_addPublishDateButtonActionPerformed

  /*
   * 
   */
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addPublishDateButton;
  private scimat.gui.components.SelectionObserverButton deletePublishDatesButton;
  private scimat.gui.components.HideAndShowPanel hideAndShowPeriodPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowPublishDatePanel;
  private scimat.gui.components.detailspanel.PeriodDetailPanel periodDetailPanel;
  private javax.swing.JPanel periodInfoPanel;
  private scimat.gui.components.slavepanel.PeriodSlavePublishDatesPanel periodSlavePublishDatesPanel;
  private javax.swing.JPanel publishDateInfoPanel;
  private javax.swing.JButton updatePeriodButton;
  // End of variables declaration//GEN-END:variables
}
