/*
 * ReferenceGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:12:01
 */
package scimat.gui.components.globalslavepanel;

import java.util.ArrayList;
import java.util.TreeSet;
import javax.swing.JOptionPane;
import scimat.gui.commands.edit.delete.DeleteAuthorReferencesFromReferenceEdit;
import scimat.gui.commands.edit.delete.DeleteReferenceSourceFromReferenceEdit;
import scimat.gui.commands.edit.update.UpdateReferenceEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.gui.components.ErrorDialogManager;
import scimat.gui.components.SelectionObserverButton;
import scimat.gui.components.adddialog.AddDialogManager;
import scimat.gui.components.editdialog.EditDialogManager;
import scimat.model.knowledgebase.dao.AuthorReferenceDAO;
import scimat.model.knowledgebase.dao.ReferenceDAO;
import scimat.model.knowledgebase.dao.ReferenceSourceDAO;
import scimat.model.knowledgebase.entity.AuthorReference;
import scimat.model.knowledgebase.entity.Reference;
import scimat.model.knowledgebase.entity.ReferenceSource;
import scimat.model.knowledgebase.exception.KnowledgeBaseException;
import scimat.project.CurrentProject;

/**
 *
 * @author mjcobo
 */
public class ReferenceGlobalSlavePanel extends GlobalSlavePanel<Reference> {

  /** Creates new form ReferenceGlobalSlavePanel */
  public ReferenceGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(Reference item) {
    
    boolean flag;
    
    setMasterItem(item);
    

    this.referenceDetailPanel.refreshItem(item);
    this.referenceSlaveReferenceGroupPanel.setMasterItem(item);
    this.referenceSlaveReferenceSourcePanel.setMasterItem(item);
    this.referenceSlaveDocumentsPanel.setMasterItem(item);
    this.referenceSlaveAuthorReferencesPanel.setMasterItem(item);

    flag = item != null;
      
    this.updateReferenceButton.setEnabled(flag);
    this.addAuthorReferenceButton.setEnabled(flag);
    this.addReferenceSourceButton.setEnabled(flag);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowReferencePanel = new scimat.gui.components.HideAndShowPanel();
    referenceInfoPanel = new javax.swing.JPanel();
    updateReferenceButton = new javax.swing.JButton();
    referenceDetailPanel = new scimat.gui.components.detailspanel.ReferenceDetailPanel();
    hideAndShowReferenceGroupPanel = new scimat.gui.components.HideAndShowPanel();
    referenceGroupInfoPanel = new javax.swing.JPanel();
    referenceSlaveReferenceGroupPanel = new scimat.gui.components.slavepanel.ReferenceSlaveReferenceGroupPanel();
    hideAndShowReferenceSourcePanel = new scimat.gui.components.HideAndShowPanel();
    referenceSourceInfoPanel = new javax.swing.JPanel();
    referenceSlaveReferenceSourcePanel = new scimat.gui.components.slavepanel.ReferenceSlaveReferenceSourcePanel();
    addReferenceSourceButton = new javax.swing.JButton();
    deleteReferenceSourceButton = new scimat.gui.components.SlaveItemObserverButton();
    hideAndShowDocumentPanel = new scimat.gui.components.HideAndShowPanel();
    documentInfoPanel = new javax.swing.JPanel();
    referenceSlaveDocumentsPanel = new scimat.gui.components.slavepanel.ReferenceSlaveDocumentsPanel();
    hideAndShowAuthorReferencePanel = new scimat.gui.components.HideAndShowPanel();
    authorReferenceInfoPanel = new javax.swing.JPanel();
    referenceSlaveAuthorReferencesPanel = new scimat.gui.components.slavepanel.ReferenceSlaveAuthorReferencesPanel();
    addAuthorReferenceButton = new javax.swing.JButton();
    updateAuthorReferencePositionButton = new SelectionObserverButton(1,1);
    this.referenceSlaveAuthorReferencesPanel.addSelectionObserver(this.updateAuthorReferencePositionButton);
    deleteAuthorReferencesButton = new SelectionObserverButton(1,-1);
    this.referenceSlaveAuthorReferencesPanel.addSelectionObserver(this.deleteAuthorReferencesButton);

    this.hideAndShowReferencePanel.setDescription("Reference info");
    this.hideAndShowReferencePanel.setPanel(this.referenceInfoPanel);

    updateReferenceButton.setText("Update");
    updateReferenceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateReferenceButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout referenceInfoPanelLayout = new javax.swing.GroupLayout(referenceInfoPanel);
    referenceInfoPanel.setLayout(referenceInfoPanelLayout);
    referenceInfoPanelLayout.setHorizontalGroup(
      referenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referenceInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateReferenceButton))
      .addComponent(referenceDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    referenceInfoPanelLayout.setVerticalGroup(
      referenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referenceInfoPanelLayout.createSequentialGroup()
        .addComponent(referenceDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateReferenceButton))
    );

    this.hideAndShowReferenceGroupPanel.setDescription("Reference group info");
    this.hideAndShowReferenceGroupPanel.setPanel(this.referenceGroupInfoPanel);

    javax.swing.GroupLayout referenceGroupInfoPanelLayout = new javax.swing.GroupLayout(referenceGroupInfoPanel);
    referenceGroupInfoPanel.setLayout(referenceGroupInfoPanelLayout);
    referenceGroupInfoPanelLayout.setHorizontalGroup(
      referenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceSlaveReferenceGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    referenceGroupInfoPanelLayout.setVerticalGroup(
      referenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceSlaveReferenceGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
    );

    this.hideAndShowReferenceSourcePanel.setDescription("Reference source info");
    this.hideAndShowReferenceSourcePanel.setPanel(this.referenceSourceInfoPanel);

    addReferenceSourceButton.setText("Set");
    addReferenceSourceButton.setEnabled(false);
    addReferenceSourceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addReferenceSourceButtonActionPerformed(evt);
      }
    });

    deleteReferenceSourceButton.setText("Delete");
    deleteReferenceSourceButton.setEnabled(false);
    this.referenceSlaveReferenceSourcePanel.addSlaveItemObserver(this.deleteReferenceSourceButton);
    deleteReferenceSourceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deleteReferenceSourceButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout referenceSourceInfoPanelLayout = new javax.swing.GroupLayout(referenceSourceInfoPanel);
    referenceSourceInfoPanel.setLayout(referenceSourceInfoPanelLayout);
    referenceSourceInfoPanelLayout.setHorizontalGroup(
      referenceSourceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceSlaveReferenceSourcePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referenceSourceInfoPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(addReferenceSourceButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(deleteReferenceSourceButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
    );
    referenceSourceInfoPanelLayout.setVerticalGroup(
      referenceSourceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(referenceSourceInfoPanelLayout.createSequentialGroup()
        .addComponent(referenceSlaveReferenceSourcePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(referenceSourceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(addReferenceSourceButton)
          .addComponent(deleteReferenceSourceButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );

    this.hideAndShowDocumentPanel.setDescription("Citing documents info");
    this.hideAndShowDocumentPanel.setPanel(this.referenceSlaveDocumentsPanel);

    javax.swing.GroupLayout documentInfoPanelLayout = new javax.swing.GroupLayout(documentInfoPanel);
    documentInfoPanel.setLayout(documentInfoPanelLayout);
    documentInfoPanelLayout.setHorizontalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceSlaveDocumentsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    documentInfoPanelLayout.setVerticalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceSlaveDocumentsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 131, Short.MAX_VALUE)
    );

    this.hideAndShowAuthorReferencePanel.setDescription("Author references info");
    this.hideAndShowAuthorReferencePanel.setPanel(this.referenceSlaveAuthorReferencesPanel);

    addAuthorReferenceButton.setText("Add");
    addAuthorReferenceButton.setEnabled(false);
    addAuthorReferenceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addAuthorReferenceButtonActionPerformed(evt);
      }
    });

    updateAuthorReferencePositionButton.setText("Update position");
    updateAuthorReferencePositionButton.setEnabled(false);
    updateAuthorReferencePositionButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateAuthorReferencePositionButtonActionPerformed(evt);
      }
    });

    deleteAuthorReferencesButton.setText("Delete");
    deleteAuthorReferencesButton.setEnabled(false);
    deleteAuthorReferencesButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deleteAuthorReferencesButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout authorReferenceInfoPanelLayout = new javax.swing.GroupLayout(authorReferenceInfoPanel);
    authorReferenceInfoPanel.setLayout(authorReferenceInfoPanelLayout);
    authorReferenceInfoPanelLayout.setHorizontalGroup(
      authorReferenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorReferenceInfoPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(addAuthorReferenceButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(updateAuthorReferencePositionButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(4, 4, 4)
        .addComponent(deleteAuthorReferencesButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
      .addComponent(referenceSlaveAuthorReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    authorReferenceInfoPanelLayout.setVerticalGroup(
      authorReferenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorReferenceInfoPanelLayout.createSequentialGroup()
        .addComponent(referenceSlaveAuthorReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 158, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(authorReferenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(deleteAuthorReferencesButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(updateAuthorReferencePositionButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(addAuthorReferenceButton)))
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(referenceSourceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(referenceGroupInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(referenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(hideAndShowReferenceGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(hideAndShowReferenceSourcePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(documentInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorReferencePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(authorReferenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowReferenceGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowReferenceSourcePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceSourceInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(documentInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAuthorReferencePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorReferenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt 
   */
  private void updateReferenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateReferenceButtonActionPerformed
    
    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.referenceDetailPanel.getFullReference().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a full reference.\nPlease, " +
        "give a full reference for the reference.", "Invalid full reference", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateReferenceEdit(getMasterItem().getReferenceID(),
              this.referenceDetailPanel.getFullReference(),
              this.referenceDetailPanel.getVolume(),
              this.referenceDetailPanel.getIssue(),
              this.referenceDetailPanel.getPage(),
              this.referenceDetailPanel.getYear(),
              this.referenceDetailPanel.getDoi(),
              this.referenceDetailPanel.getFormat()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateReferenceButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addReferenceSourceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addReferenceSourceButtonActionPerformed
    
    
    try {
      
      ReferenceDAO referenceDAO = CurrentProject.getInstance().getFactoryDAO().getReferenceDAO();
      ReferenceSourceDAO referenceSourceDAO = CurrentProject.getInstance().getFactoryDAO().getReferenceSourceDAO();
      
      ReferenceSource referenceSource = referenceDAO.getReferenceSource(getMasterItem().getReferenceID());
      TreeSet<ReferenceSource> referenceSources = new TreeSet<ReferenceSource>(referenceSourceDAO.getReferenceSources());
      
      if (referenceSource != null) {
        
        referenceSources.remove(referenceSource);
      }
      
      AddDialogManager.getInstance().showAddReferenceSourcesToReferenceDialog(getMasterItem(), new ArrayList<ReferenceSource>(referenceSources));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
}//GEN-LAST:event_addReferenceSourceButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteReferenceSourceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteReferenceSourceButtonActionPerformed
    
    (new PerformKnowledgeBaseEditTask(new DeleteReferenceSourceFromReferenceEdit(this.getMasterItem()),this)).execute();
}//GEN-LAST:event_deleteReferenceSourceButtonActionPerformed

  /**
   * 
   */
  private void addAuthorReferenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAuthorReferenceButtonActionPerformed
    
    try {
      
      ReferenceDAO referenceDAO = CurrentProject.getInstance().getFactoryDAO().getReferenceDAO();
      AuthorReferenceDAO authorReferenceDAO = CurrentProject.getInstance().getFactoryDAO().getAuthorReferenceDAO();
      
      ArrayList<AuthorReference> authorsInDocument = referenceDAO.getAuthorReferences(getMasterItem().getReferenceID());
      TreeSet<AuthorReference> possibleAuthors = new TreeSet<AuthorReference>(authorReferenceDAO.getAuthorReferences());
      
      possibleAuthors.removeAll(authorsInDocument);
      
      AddDialogManager.getInstance().showAddAuthorReferencesToReferenceDialog(getMasterItem(), new ArrayList<AuthorReference>(possibleAuthors));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
}//GEN-LAST:event_addAuthorReferenceButtonActionPerformed

  
  /**
   * 
   * @param evt 
   */
  private void updateAuthorReferencePositionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateAuthorReferencePositionButtonActionPerformed
    EditDialogManager.getInstance().showUpdateAuthorReferenceReferencePositionDialog(this.referenceSlaveAuthorReferencesPanel.getSelectedItems().get(0));
  }//GEN-LAST:event_updateAuthorReferencePositionButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteAuthorReferencesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAuthorReferencesButtonActionPerformed
    (new PerformKnowledgeBaseEditTask(new DeleteAuthorReferencesFromReferenceEdit(this.getMasterItem(), this.referenceSlaveAuthorReferencesPanel.getSelectedItems()), this)).execute();
  }//GEN-LAST:event_deleteAuthorReferencesButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addAuthorReferenceButton;
  private javax.swing.JButton addReferenceSourceButton;
  private javax.swing.JPanel authorReferenceInfoPanel;
  private scimat.gui.components.SelectionObserverButton deleteAuthorReferencesButton;
  private scimat.gui.components.SlaveItemObserverButton deleteReferenceSourceButton;
  private javax.swing.JPanel documentInfoPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorReferencePanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowDocumentPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowReferenceGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowReferencePanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowReferenceSourcePanel;
  private scimat.gui.components.detailspanel.ReferenceDetailPanel referenceDetailPanel;
  private javax.swing.JPanel referenceGroupInfoPanel;
  private javax.swing.JPanel referenceInfoPanel;
  private scimat.gui.components.slavepanel.ReferenceSlaveAuthorReferencesPanel referenceSlaveAuthorReferencesPanel;
  private scimat.gui.components.slavepanel.ReferenceSlaveDocumentsPanel referenceSlaveDocumentsPanel;
  private scimat.gui.components.slavepanel.ReferenceSlaveReferenceGroupPanel referenceSlaveReferenceGroupPanel;
  private scimat.gui.components.slavepanel.ReferenceSlaveReferenceSourcePanel referenceSlaveReferenceSourcePanel;
  private javax.swing.JPanel referenceSourceInfoPanel;
  private scimat.gui.components.SelectionObserverButton updateAuthorReferencePositionButton;
  private javax.swing.JButton updateReferenceButton;
  // End of variables declaration//GEN-END:variables
}
