/*
 * ReferenceSourceGroupGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:13:11
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateReferenceSourceGroupEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.ReferenceSourceGroup;

/**
 *
 * @author mjcobo
 */
public class ReferenceSourceGroupGlobalSlavePanel extends GlobalSlavePanel<ReferenceSourceGroup> {

  /** Creates new form ReferenceSourceGroupGlobalSlavePanel */
  public ReferenceSourceGroupGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(ReferenceSourceGroup item) {

    setMasterItem(item);

    this.referenceSourceGroupDetailPanel.refreshItem(item);
    this.referenceSourceGroupSlaveReferenceSourcesPanel.setMasterItem(item);

    if (item != null) {
      
      this.updateReferenceSourceGroupButton.setEnabled(true);

    } else {

      this.referenceSourceGroupDetailPanel.refreshItem(null);

    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowReferenceSourceGroupPanel = new scimat.gui.components.HideAndShowPanel();
    referenceSourceGroupInfoPanel = new javax.swing.JPanel();
    updateReferenceSourceGroupButton = new javax.swing.JButton();
    referenceSourceGroupDetailPanel = new scimat.gui.components.detailspanel.ReferenceSourceGroupDetailPanel();
    hideAndShowReferenceSourcePanel = new scimat.gui.components.HideAndShowPanel();
    referenceSourceInfoPanel = new javax.swing.JPanel();
    referenceSourceGroupSlaveReferenceSourcesPanel = new scimat.gui.components.slavepanel.ReferenceSourceGroupSlaveReferenceSourcesPanel();

    this.hideAndShowReferenceSourceGroupPanel.setDescription("Sources-reference group");
    this.hideAndShowReferenceSourceGroupPanel.setPanel(this.referenceSourceGroupInfoPanel);

    updateReferenceSourceGroupButton.setText("Update");
    updateReferenceSourceGroupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateReferenceSourceGroupButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout referenceSourceGroupInfoPanelLayout = new javax.swing.GroupLayout(referenceSourceGroupInfoPanel);
    referenceSourceGroupInfoPanel.setLayout(referenceSourceGroupInfoPanelLayout);
    referenceSourceGroupInfoPanelLayout.setHorizontalGroup(
      referenceSourceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referenceSourceGroupInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateReferenceSourceGroupButton))
      .addComponent(referenceSourceGroupDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    referenceSourceGroupInfoPanelLayout.setVerticalGroup(
      referenceSourceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referenceSourceGroupInfoPanelLayout.createSequentialGroup()
        .addComponent(referenceSourceGroupDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateReferenceSourceGroupButton))
    );

    this.hideAndShowReferenceSourcePanel.setDescription("Sources-reference info");
    this.hideAndShowReferenceSourcePanel.setPanel(this.referenceSourceInfoPanel);

    javax.swing.GroupLayout referenceSourceInfoPanelLayout = new javax.swing.GroupLayout(referenceSourceInfoPanel);
    referenceSourceInfoPanel.setLayout(referenceSourceInfoPanelLayout);
    referenceSourceInfoPanelLayout.setHorizontalGroup(
      referenceSourceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceSourceGroupSlaveReferenceSourcesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    referenceSourceInfoPanelLayout.setVerticalGroup(
      referenceSourceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceSourceGroupSlaveReferenceSourcesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(referenceSourceGroupInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowReferenceSourceGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(referenceSourceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowReferenceSourcePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowReferenceSourceGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceSourceGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowReferenceSourcePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceSourceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateReferenceSourceGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateReferenceSourceGroupButtonActionPerformed
    
    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.referenceSourceGroupDetailPanel.getGroupName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a group name.\nPlease, " +
        "give a name for the group.", "Invalid group name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateReferenceSourceGroupEdit(getMasterItem().getReferenceSourceGroupID(),
              this.referenceSourceGroupDetailPanel.getGroupName(),
              this.referenceSourceGroupDetailPanel.isStopGroup()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateReferenceSourceGroupButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private scimat.gui.components.HideAndShowPanel hideAndShowReferenceSourceGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowReferenceSourcePanel;
  private scimat.gui.components.detailspanel.ReferenceSourceGroupDetailPanel referenceSourceGroupDetailPanel;
  private javax.swing.JPanel referenceSourceGroupInfoPanel;
  private scimat.gui.components.slavepanel.ReferenceSourceGroupSlaveReferenceSourcesPanel referenceSourceGroupSlaveReferenceSourcesPanel;
  private javax.swing.JPanel referenceSourceInfoPanel;
  private javax.swing.JButton updateReferenceSourceGroupButton;
  // End of variables declaration//GEN-END:variables
}
