/*
 * WordGroupGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:11:04
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateWordGroupEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.WordGroup;

/**
 *
 * @author mjcobo
 */
public class WordGroupGlobalSlavePanel extends GlobalSlavePanel<WordGroup> {

  /** Creates new form WordGroupGlobalSlavePanel */
  public WordGroupGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(WordGroup item) {

    setMasterItem(item);

    this.wordGroupDetailPanel.refreshItem(item);
    this.wordGroupSlaveWordsPanel.setMasterItem(item);

    if (item != null) {
      
      this.updateWordGroupButton.setEnabled(true);

    } else {
      
      this.updateWordGroupButton.setEnabled(false);

    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowWordGroupPanel = new scimat.gui.components.HideAndShowPanel();
    wordGroupInfoPanel = new javax.swing.JPanel();
    updateWordGroupButton = new javax.swing.JButton();
    wordGroupDetailPanel = new scimat.gui.components.detailspanel.WordGroupDetailPanel();
    hideAndShowWordPanel = new scimat.gui.components.HideAndShowPanel();
    wordInfoPanel = new javax.swing.JPanel();
    wordGroupSlaveWordsPanel = new scimat.gui.components.slavepanel.WordGroupSlaveWordsPanel();

    this.hideAndShowWordPanel.setDescription("Word group info");
    this.hideAndShowWordPanel.setPanel(this.wordInfoPanel);

    updateWordGroupButton.setText("Update");
    updateWordGroupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateWordGroupButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout wordGroupInfoPanelLayout = new javax.swing.GroupLayout(wordGroupInfoPanel);
    wordGroupInfoPanel.setLayout(wordGroupInfoPanelLayout);
    wordGroupInfoPanelLayout.setHorizontalGroup(
      wordGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, wordGroupInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateWordGroupButton))
      .addComponent(wordGroupDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    wordGroupInfoPanelLayout.setVerticalGroup(
      wordGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, wordGroupInfoPanelLayout.createSequentialGroup()
        .addComponent(wordGroupDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateWordGroupButton))
    );

    this.hideAndShowWordPanel.setDescription("Words info");
    this.hideAndShowWordPanel.setPanel(this.wordInfoPanel);

    javax.swing.GroupLayout wordInfoPanelLayout = new javax.swing.GroupLayout(wordInfoPanel);
    wordInfoPanel.setLayout(wordInfoPanelLayout);
    wordInfoPanelLayout.setHorizontalGroup(
      wordInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(wordGroupSlaveWordsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    wordInfoPanelLayout.setVerticalGroup(
      wordInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(wordGroupSlaveWordsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(wordGroupInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowWordGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(wordInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowWordPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowWordGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(wordGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowWordPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(wordInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateWordGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateWordGroupButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.wordGroupDetailPanel.getGroupName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a group name.\nPlease, " +
        "give a name for the group.", "Invalid group name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateWordGroupEdit(getMasterItem().getWordGroupID(),
              this.wordGroupDetailPanel.getGroupName(),
              this.wordGroupDetailPanel.isStopGroup()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateWordGroupButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private scimat.gui.components.HideAndShowPanel hideAndShowWordGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowWordPanel;
  private javax.swing.JButton updateWordGroupButton;
  private scimat.gui.components.detailspanel.WordGroupDetailPanel wordGroupDetailPanel;
  private javax.swing.JPanel wordGroupInfoPanel;
  private scimat.gui.components.slavepanel.WordGroupSlaveWordsPanel wordGroupSlaveWordsPanel;
  private javax.swing.JPanel wordInfoPanel;
  // End of variables declaration//GEN-END:variables
}
