/*
 * GenericManualSetGroupPanel.java
 *
 * Created on 23-mar-2011, 18:47:13
 */
package scimat.gui.components.manager;

import java.util.ArrayList;
import scimat.gui.components.SelectionObserverButton;
import scimat.gui.components.itemslist.GenericItemsListPanel;
import scimat.gui.components.observer.SelectionObserver;
import scimat.gui.components.slavepanel.GenericSlaveListPanel;

/**
 * 
 * @author mjcobo
 * @param <EM>
 * @param <EMV>
 * @param <ES>
 * @param <ESV>
 */
public abstract class GenericManualSetGroupPanel<EM extends Comparable<EM>,
                                                 ES extends Comparable<ES>> 
                                                 extends javax.swing.JPanel implements SelectionObserver {

  /** Creates new form GenericManualSetGroupPanel */
  public GenericManualSetGroupPanel(GenericItemsListPanel<EM> genericGroupListPanel,
                                    GenericItemsListPanel<ES> genericItemsWithoutGroupListPanel, 
                                    GenericSlaveListPanel<EM, ES> genericItemsSlaveList) {

    this.genericGroupListPanel = genericGroupListPanel;
    this.genericItemsWithoutGroupListPanel = genericItemsWithoutGroupListPanel;
    this.genericItemsSlaveList = genericItemsSlaveList;
    
    initComponents();

    this.groupsListPanel.add(this.genericGroupListPanel);
    this.itemsListSlavePanel.add(this.genericItemsSlaveList);
    this.itemsWithouGroupListPanel.add(this.genericItemsWithoutGroupListPanel);

    this.genericGroupListPanel.addSelectionObserver(this);
  }

  /**
   *
   */
  public void setDescription(String groupsTitle, String slaveItemsTitle, String itemsWithOutGroupTitle) {

    this.leftScrollPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(groupsTitle));
    this.itemsListSlavePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(slaveItemsTitle));
    this.itemsWithouGroupListPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(itemsWithOutGroupTitle));
  }

  /**
   *
   * @param selection
   */
  public void selectionChangeHappened(int[] selection) {

    if (selection.length == 0) {

      this.genericItemsSlaveList.setMasterItem(null);

    } else if (selection.length == 1) {
      
      this.genericItemsSlaveList.setMasterItem(this.genericGroupListPanel.getItem(selection[0]));

    } else {

      this.genericItemsSlaveList.setMasterItem(null);
    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainSplitPane = new javax.swing.JSplitPane();
        leftScrollPanel = new javax.swing.JScrollPane();
        leftPanel = new javax.swing.JPanel();
        groupsListPanel = new javax.swing.JPanel();
        separator = new javax.swing.JSeparator();
        addButton = new javax.swing.JButton();
        moveToButton = new SelectionObserverButton(2,-1);
        deleteButton = new SelectionObserverButton(1,-1);
        editKeywordsGroupsButton = new SelectionObserverButton(1,1);
        rightScrollPanel = new javax.swing.JScrollPane();
        rightPanel = new javax.swing.JPanel();
        itemsListSlavePanel = new javax.swing.JPanel();
        removeItemFromGroupButton = new SelectionObserverButton(1,-1);
        addItemToGroupButton = new SelectionObserverButton(1,-1);
        itemsWithouGroupListPanel = new javax.swing.JPanel();
        separator2 = new javax.swing.JSeparator();
        deleteGroupButton = new SelectionObserverButton(1,-1);
        moveToNewGroupButton = new SelectionObserverButton(1,-1);
        moveToDifferentGroupButton = new SelectionObserverButton(1,-1);

        mainSplitPane.setBorder(null);
        mainSplitPane.setDividerLocation(400);

        leftScrollPanel.setBorder(null);

        groupsListPanel.setLayout(new javax.swing.BoxLayout(groupsListPanel, javax.swing.BoxLayout.LINE_AXIS));

        addButton.setText("Add");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        moveToButton.setText("Move to");
        moveToButton.setEnabled(false);
        this.genericGroupListPanel.addSelectionObserver(this.moveToButton);
        moveToButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveToButtonActionPerformed(evt);
            }
        });

        deleteButton.setText("Delete");
        deleteButton.setEnabled(false);
        this.genericGroupListPanel.addSelectionObserver(this.deleteButton);
        deleteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteButtonActionPerformed(evt);
            }
        });

        editKeywordsGroupsButton.setText("Edit");
        editKeywordsGroupsButton.setEnabled(false);
        this.genericGroupListPanel.addSelectionObserver(editKeywordsGroupsButton);
        editKeywordsGroupsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editKeywordsGroupsButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout leftPanelLayout = new javax.swing.GroupLayout(leftPanel);
        leftPanel.setLayout(leftPanelLayout);
        leftPanelLayout.setHorizontalGroup(
            leftPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(leftPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(leftPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(separator, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
                    .addComponent(groupsListPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, leftPanelLayout.createSequentialGroup()
                        .addComponent(addButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(editKeywordsGroupsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(moveToButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(deleteButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        leftPanelLayout.setVerticalGroup(
            leftPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, leftPanelLayout.createSequentialGroup()
                .addComponent(groupsListPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 479, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(separator, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(leftPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(deleteButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(moveToButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(addButton)
                    .addComponent(editKeywordsGroupsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        leftScrollPanel.setViewportView(leftPanel);

        mainSplitPane.setLeftComponent(leftScrollPanel);

        rightScrollPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        itemsListSlavePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        itemsListSlavePanel.setLayout(new javax.swing.BoxLayout(itemsListSlavePanel, javax.swing.BoxLayout.LINE_AXIS));

        removeItemFromGroupButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/down16x16.png"))); // NOI18N
        removeItemFromGroupButton.setText("");
        removeItemFromGroupButton.setEnabled(false);
        this.genericItemsSlaveList.addSelectionObserver(this.removeItemFromGroupButton);
        removeItemFromGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeItemFromGroupButtonActionPerformed(evt);
            }
        });

        addItemToGroupButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/up16x16.png"))); // NOI18N
        addItemToGroupButton.setText("");
        addItemToGroupButton.setEnabled(false);
        this.genericItemsWithoutGroupListPanel.addSelectionObserver(new SelectionObserver() {

            public void selectionChangeHappened(int[] selection) {

                if ((selection.length > 0) &&
                    (genericGroupListPanel.getSelectedRows().length == 1)) {

                    addItemToGroupButton.setEnabled(true);

                } else {

                    addItemToGroupButton.setEnabled(false);
                }
            }
        });

        this.genericGroupListPanel.addSelectionObserver(new SelectionObserver() {

            public void selectionChangeHappened(int[] selection) {

                if ((selection.length == 1) &&
                    (genericItemsWithoutGroupListPanel.getSelectedRows().length > 0)) {

                    addItemToGroupButton.setEnabled(true);

                } else {

                    addItemToGroupButton.setEnabled(false);
                }

            }
        });
        addItemToGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addItemToGroupButtonActionPerformed(evt);
            }
        });

        itemsWithouGroupListPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        itemsWithouGroupListPanel.setLayout(new javax.swing.BoxLayout(itemsWithouGroupListPanel, javax.swing.BoxLayout.LINE_AXIS));

        deleteGroupButton.setText("Delete");
        deleteGroupButton.setEnabled(false);
        this.genericItemsWithoutGroupListPanel.addSelectionObserver(this.deleteGroupButton);
        deleteGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deleteGroupButtonActionPerformed(evt);
            }
        });

        moveToNewGroupButton.setText("To new group");
        moveToNewGroupButton.setEnabled(false);
        this.genericItemsWithoutGroupListPanel.addSelectionObserver(this.moveToNewGroupButton);
        moveToNewGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveToNewGroupButtonActionPerformed(evt);
            }
        });

        moveToDifferentGroupButton.setText("To different group");
        moveToDifferentGroupButton.setEnabled(false);
        this.genericItemsWithoutGroupListPanel.addSelectionObserver(this.moveToDifferentGroupButton);
        moveToDifferentGroupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                moveToDifferentGroupButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout rightPanelLayout = new javax.swing.GroupLayout(rightPanel);
        rightPanel.setLayout(rightPanelLayout);
        rightPanelLayout.setHorizontalGroup(
            rightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(rightPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(rightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(itemsListSlavePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 455, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.CENTER, rightPanelLayout.createSequentialGroup()
                        .addComponent(addItemToGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(removeItemFromGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(itemsWithouGroupListPanel, javax.swing.GroupLayout.Alignment.CENTER, javax.swing.GroupLayout.DEFAULT_SIZE, 455, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, rightPanelLayout.createSequentialGroup()
                        .addComponent(deleteGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(moveToNewGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(moveToDifferentGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(separator2, javax.swing.GroupLayout.DEFAULT_SIZE, 455, Short.MAX_VALUE))
                .addContainerGap())
        );
        rightPanelLayout.setVerticalGroup(
            rightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(rightPanelLayout.createSequentialGroup()
                .addComponent(itemsListSlavePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 164, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(rightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(removeItemFromGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(addItemToGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(itemsWithouGroupListPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 265, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(separator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(rightPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(moveToDifferentGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(moveToNewGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(deleteGroupButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        rightScrollPanel.setViewportView(rightPanel);

        mainSplitPane.setRightComponent(rightScrollPanel);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainSplitPane, javax.swing.GroupLayout.DEFAULT_SIZE, 892, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainSplitPane, javax.swing.GroupLayout.DEFAULT_SIZE, 535, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   */
  public abstract void addGroupAction();

  /**
   * 
   * @param group 
   */
  public abstract void editGroupAction(EM group);

  /**
   * 
   * @param groups 
   */
  public abstract void moveGroupToAction(ArrayList<EM> groups);

  /**
   * 
   * @param groups 
   */
  public abstract void deleteGroupAction(ArrayList<EM> groups);

  /**
   * 
   * @param itemsWithoutGroup 
   */
  public abstract void toNewGroupAction(ArrayList<ES> itemsWithoutGroup);

  /**
   * 
   * @param itemsWithoutGroup 
   */
  public abstract void toDifferentGroupAction(ArrayList<ES> itemsWithoutGroup);

  /**
   * 
   * @param itemsFromGroup
   * @param group 
   */
  public abstract void removeItemFromGroupAction(ArrayList<ES> itemsFromGroup, EM group);

  /**
   * 
   * @param group
   * @param itemsWithoutGroup 
   */
  public abstract void addItemToGroupAction(EM group, ArrayList<ES> itemsWithoutGroup);
  
  /**
   * 
   * @param itemsWithoutGroup 
   */
  public abstract void removeItemsWithoutGroup(ArrayList<ES> itemsWithoutGroup);

  /**
   * 
   * @param evt
   */
  private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
    addGroupAction();
  }//GEN-LAST:event_addButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void editKeywordsGroupsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editKeywordsGroupsButtonActionPerformed
    
    editGroupAction(this.genericGroupListPanel.getSelectedItems().get(0));
  }//GEN-LAST:event_editKeywordsGroupsButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void moveToButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveToButtonActionPerformed
    
    moveGroupToAction(this.genericGroupListPanel.getSelectedItems());
  }//GEN-LAST:event_moveToButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void deleteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteButtonActionPerformed
    
    deleteGroupAction(this.genericGroupListPanel.getSelectedItems());
  }//GEN-LAST:event_deleteButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void moveToNewGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveToNewGroupButtonActionPerformed
    
    toNewGroupAction(this.genericItemsWithoutGroupListPanel.getSelectedItems());
  }//GEN-LAST:event_moveToNewGroupButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void moveToDifferentGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_moveToDifferentGroupButtonActionPerformed
    
    toDifferentGroupAction(this.genericItemsWithoutGroupListPanel.getSelectedItems());
  }//GEN-LAST:event_moveToDifferentGroupButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void addItemToGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addItemToGroupButtonActionPerformed
    
    addItemToGroupAction(this.genericGroupListPanel.getSelectedItems().get(0),
                         this.genericItemsWithoutGroupListPanel.getSelectedItems());
  }//GEN-LAST:event_addItemToGroupButtonActionPerformed

  /**
   * 
   * @param evt
   */
  private void removeItemFromGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeItemFromGroupButtonActionPerformed
    
    removeItemFromGroupAction(this.genericItemsSlaveList.getSelectedItems(), 
                              this.genericGroupListPanel.getSelectedItems().get(0));
  }//GEN-LAST:event_removeItemFromGroupButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteGroupButtonActionPerformed
    removeItemsWithoutGroup(this.genericItemsWithoutGroupListPanel.getSelectedItems());
  }//GEN-LAST:event_deleteGroupButtonActionPerformed

  /**
   * 
   * @param evt
   */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private scimat.gui.components.SelectionObserverButton addItemToGroupButton;
    private scimat.gui.components.SelectionObserverButton deleteButton;
    private scimat.gui.components.SelectionObserverButton deleteGroupButton;
    private scimat.gui.components.SelectionObserverButton editKeywordsGroupsButton;
    private javax.swing.JPanel groupsListPanel;
    private javax.swing.JPanel itemsListSlavePanel;
    private javax.swing.JPanel itemsWithouGroupListPanel;
    private javax.swing.JPanel leftPanel;
    private javax.swing.JScrollPane leftScrollPanel;
    private javax.swing.JSplitPane mainSplitPane;
    private scimat.gui.components.SelectionObserverButton moveToButton;
    private scimat.gui.components.SelectionObserverButton moveToDifferentGroupButton;
    private scimat.gui.components.SelectionObserverButton moveToNewGroupButton;
    private scimat.gui.components.SelectionObserverButton removeItemFromGroupButton;
    private javax.swing.JPanel rightPanel;
    private javax.swing.JScrollPane rightScrollPanel;
    private javax.swing.JSeparator separator;
    private javax.swing.JSeparator separator2;
    // End of variables declaration//GEN-END:variables
  private GenericItemsListPanel<EM> genericGroupListPanel;
  private GenericItemsListPanel<ES> genericItemsWithoutGroupListPanel;
  private GenericSlaveListPanel<EM, ES> genericItemsSlaveList;
}
