/*
 * SelectUnitOfAnalysisPanel.java
 *
 * Created on 03-abr-2011, 17:52:13
 */
package scimat.gui.components.wizard.Analysis;

import scimat.analysis.KindOfMatrixEnum;
import scimat.gui.components.wizard.GenericWizardStepPanel;

/**
 *
 * @author mjcobo
 */
public class SelectMatrixBuilderPanel extends GenericWizardStepPanel {

  /** Creates new form SelectUnitOfAnalysisPanel */
  public SelectMatrixBuilderPanel() {
    initComponents();

    //unitOfAnalysisButtonGroup.
  }

  /**
   * 
   */
  @Override
  public void refresh() {
    this.kindOfMatrixButtonGroup.clearSelection();
    fireIncorrectDataObservers();
  }

  /**
   * 
   */
  @Override
  public void fireIncorrectDataObservers() {

    if (this.kindOfMatrixButtonGroup.getSelection() != null) {

      notifyIncorrectDataObservers(true, "");

    } else {

      notifyIncorrectDataObservers(false, "A kind of matrix must be selected.");
    }
  }

  /**
   * 
   * @return
   */
  public KindOfMatrixEnum getSelectedKindOfMatrix() {

    KindOfMatrixEnum kindOfMatrix = null;

    if (this.coOccurrenceRadioButton.isSelected()) {

      kindOfMatrix = KindOfMatrixEnum.CoOccurrence;

    } else if (this.basicCouplingRadioButton.isSelected()) {

      kindOfMatrix = KindOfMatrixEnum.BasicCoupling;

    } else if (this.aggregatedCouplingBasedOnAuthorsRadioButton.isSelected()) {

      kindOfMatrix = KindOfMatrixEnum.AggregatedCouplingBasedOnAuthor;

    } else if (this.aggregatedCouplingBasedOnJournalsReferencesRadioButton.isSelected()) {

      kindOfMatrix = KindOfMatrixEnum.AggregatedCouplingBasedOnJournal;
    }

    return kindOfMatrix;
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    kindOfMatrixButtonGroup = new javax.swing.ButtonGroup();
    coOccurrenceRadioButton = new javax.swing.JRadioButton();
    basicCouplingRadioButton = new javax.swing.JRadioButton();
    aggregatedCouplingBasedOnAuthorsRadioButton = new javax.swing.JRadioButton();
    aggregatedCouplingBasedOnJournalsReferencesRadioButton = new javax.swing.JRadioButton();

    kindOfMatrixButtonGroup.add(coOccurrenceRadioButton);
    coOccurrenceRadioButton.setText("Co-occurrence");
    coOccurrenceRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        coOccurrenceRadioButtonActionPerformed(evt);
      }
    });

    kindOfMatrixButtonGroup.add(basicCouplingRadioButton);
    basicCouplingRadioButton.setText("Basic coupling");
    basicCouplingRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        basicCouplingRadioButtonActionPerformed(evt);
      }
    });

    kindOfMatrixButtonGroup.add(aggregatedCouplingBasedOnAuthorsRadioButton);
    aggregatedCouplingBasedOnAuthorsRadioButton.setText("Aggregated coupling based on authors");
    aggregatedCouplingBasedOnAuthorsRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        aggregatedCouplingBasedOnAuthorsRadioButtonActionPerformed(evt);
      }
    });

    kindOfMatrixButtonGroup.add(aggregatedCouplingBasedOnJournalsReferencesRadioButton);
    aggregatedCouplingBasedOnJournalsReferencesRadioButton.setText("Aggregated coupling based on journals");
    aggregatedCouplingBasedOnJournalsReferencesRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        aggregatedCouplingBasedOnJournalsReferencesRadioButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(coOccurrenceRadioButton)
          .addComponent(basicCouplingRadioButton)
          .addComponent(aggregatedCouplingBasedOnAuthorsRadioButton)
          .addComponent(aggregatedCouplingBasedOnJournalsReferencesRadioButton))
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(coOccurrenceRadioButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(basicCouplingRadioButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(aggregatedCouplingBasedOnAuthorsRadioButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(aggregatedCouplingBasedOnJournalsReferencesRadioButton))
    );
  }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt
   */
  private void coOccurrenceRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coOccurrenceRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_coOccurrenceRadioButtonActionPerformed

  private void basicCouplingRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_basicCouplingRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_basicCouplingRadioButtonActionPerformed

  private void aggregatedCouplingBasedOnAuthorsRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aggregatedCouplingBasedOnAuthorsRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_aggregatedCouplingBasedOnAuthorsRadioButtonActionPerformed

  private void aggregatedCouplingBasedOnJournalsReferencesRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aggregatedCouplingBasedOnJournalsReferencesRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_aggregatedCouplingBasedOnJournalsReferencesRadioButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JRadioButton aggregatedCouplingBasedOnAuthorsRadioButton;
  private javax.swing.JRadioButton aggregatedCouplingBasedOnJournalsReferencesRadioButton;
  private javax.swing.JRadioButton basicCouplingRadioButton;
  private javax.swing.JRadioButton coOccurrenceRadioButton;
  private javax.swing.ButtonGroup kindOfMatrixButtonGroup;
  // End of variables declaration//GEN-END:variables
}
