/*
 * SelectSimilarityMeasurePanel.java
 *
 * Created on 03-abr-2011, 19:22:21
 */
package scimat.gui.components.wizard.Analysis;

import scimat.analysis.SimilarityMeasuresEnum;
import scimat.gui.components.wizard.GenericWizardStepPanel;

/**
 *
 * @author mjcobo
 */
public class SelectSimilarityMeasurePanel extends GenericWizardStepPanel {

  /** Creates new form SelectSimilarityMeasurePanel */
  public SelectSimilarityMeasurePanel() {
    initComponents();
  }

  /**
   * 
   */
  @Override
  public void refresh() {
    this.normalizationMeasuresButtonGroup.clearSelection();
    fireIncorrectDataObservers();
  }

  /**
   *
   */
  @Override
  public void fireIncorrectDataObservers() {
    
    if (this.normalizationMeasuresButtonGroup.getSelection() != null) {

      notifyIncorrectDataObservers(true, "");

    } else {

      notifyIncorrectDataObservers(false, "A similarity measure must be selected.");
    }
  }

  /**
   * 
   * @return
   */
  public SimilarityMeasuresEnum getSelectedNormalizationMeasures() {

    SimilarityMeasuresEnum normalizationMeasures = null;

    if (this.associationStrengthRadioButton.isSelected()) {

      normalizationMeasures = SimilarityMeasuresEnum.AssociationStrength;

    } else if (this.equivalenceIndexRadioButton.isSelected()) {

      normalizationMeasures = SimilarityMeasuresEnum.EquivalenceIndex;

    } else if (this.inclusionIndexRadioButton.isSelected()) {

      normalizationMeasures = SimilarityMeasuresEnum.InclusionIndex;

    } else if (this.jaccardIndexRadioButton.isSelected()) {

      normalizationMeasures = SimilarityMeasuresEnum.JaccardIndex;

    } else if (this.saltonCosineRadioButton.isSelected()) {

      normalizationMeasures = SimilarityMeasuresEnum.SaltonCosine;
    }

    return normalizationMeasures;
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    normalizationMeasuresButtonGroup = new javax.swing.ButtonGroup();
    associationStrengthRadioButton = new javax.swing.JRadioButton();
    equivalenceIndexRadioButton = new javax.swing.JRadioButton();
    inclusionIndexRadioButton = new javax.swing.JRadioButton();
    jaccardIndexRadioButton = new javax.swing.JRadioButton();
    saltonCosineRadioButton = new javax.swing.JRadioButton();

    normalizationMeasuresButtonGroup.add(associationStrengthRadioButton);
    associationStrengthRadioButton.setText("Association strength");
    associationStrengthRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        associationStrengthRadioButtonActionPerformed(evt);
      }
    });

    normalizationMeasuresButtonGroup.add(equivalenceIndexRadioButton);
    equivalenceIndexRadioButton.setText("Equivalence index");
    equivalenceIndexRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        equivalenceIndexRadioButtonActionPerformed(evt);
      }
    });

    normalizationMeasuresButtonGroup.add(inclusionIndexRadioButton);
    inclusionIndexRadioButton.setText("Inclussion index");
    inclusionIndexRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        inclusionIndexRadioButtonActionPerformed(evt);
      }
    });

    normalizationMeasuresButtonGroup.add(jaccardIndexRadioButton);
    jaccardIndexRadioButton.setText("Jaccard's index");
    jaccardIndexRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jaccardIndexRadioButtonActionPerformed(evt);
      }
    });

    normalizationMeasuresButtonGroup.add(saltonCosineRadioButton);
    saltonCosineRadioButton.setText("Salton's cosine");
    saltonCosineRadioButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        saltonCosineRadioButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(associationStrengthRadioButton)
      .addComponent(equivalenceIndexRadioButton)
      .addComponent(inclusionIndexRadioButton)
      .addComponent(jaccardIndexRadioButton)
      .addComponent(saltonCosineRadioButton)
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(associationStrengthRadioButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(equivalenceIndexRadioButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(inclusionIndexRadioButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(jaccardIndexRadioButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(saltonCosineRadioButton))
    );
  }// </editor-fold>//GEN-END:initComponents

  /**
   *
   * @param evt
   */
  private void associationStrengthRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_associationStrengthRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_associationStrengthRadioButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void equivalenceIndexRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_equivalenceIndexRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_equivalenceIndexRadioButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void inclusionIndexRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_inclusionIndexRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_inclusionIndexRadioButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void jaccardIndexRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jaccardIndexRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_jaccardIndexRadioButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void saltonCosineRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saltonCosineRadioButtonActionPerformed
    fireIncorrectDataObservers();
  }//GEN-LAST:event_saltonCosineRadioButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JRadioButton associationStrengthRadioButton;
  private javax.swing.JRadioButton equivalenceIndexRadioButton;
  private javax.swing.JRadioButton inclusionIndexRadioButton;
  private javax.swing.JRadioButton jaccardIndexRadioButton;
  private javax.swing.ButtonGroup normalizationMeasuresButtonGroup;
  private javax.swing.JRadioButton saltonCosineRadioButton;
  // End of variables declaration//GEN-END:variables
}
